//--------------------------------------------------------INCLUDE------------------------------------------------------//
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "string.h"

//--------------------------------------------------------DEFINE-------------------------------------------------------//
#define BUTTON 10
#define SECONDE 1000
#define OLED_RESET 0  
#define TRIGGER_PIN 15
#define ECHO_PIN 14

//--------------------------------------------------------PRE-INIT-----------------------------------------------------//
Adafruit_SSD1306 OLED(OLED_RESET);

//Constantes pour le timeout 
const unsigned long MEASURE_TIMEOUT = 25000UL; // 25ms = ~8m à 340m/s

// Vitesse du son dans l'air en mm/us 
const float SOUND_SPEED = 340.0 / 1000;

// Précédente valeur de millis()
unsigned long previousMillis = 0;

//horloge
unsigned char seconde=0;
unsigned char minute=0;
unsigned char heure=0;

//chrono
unsigned char seconde_c=0;
unsigned char minute_c=0;
unsigned char heure_c=0;

//--------------------------------------------------------INITIALISATION-------------------------------------------------//
void initial()
{
  /* Initialise les broches */
//  pinMode(TRIGGER_PIN, OUTPUT);
//  digitalWrite(TRIGGER_PIN, LOW); // La broche TRIGGER doit être à LOW au repos
//  pinMode(ECHO_PIN, INPUT);

  //affichage ecran
  OLED.begin();
  OLED.clearDisplay();
  OLED.setTextWrap(false);
  OLED.setTextSize(1);
  OLED.setTextColor(WHITE); 
  //testdrawrect();
  OLED.clearDisplay();
  for(int16_t i=0; i<OLED.height()/2; i+=2) {
    OLED.drawRect(i, i, OLED.width()-2*i, OLED.height()-2*i, WHITE);
    OLED.display(); // Update screen with each newly-drawn rectangle
    delay(1);
  }
  delay(2000);
  OLED.clearDisplay();
  OLED.setTextSize(4);
  OLED.setCursor(0,0);
  OLED.println("HELLO");
  OLED.display();
  //OLED.startscrollleft(0x00, 0x0F); //make display scroll 
  delay(1000);
}

//--------------------------------------------------------HORLOGE-----------------------------------------------------//
void horloge()
{
 // Récupère la valeur actuelle de millis()
 unsigned long currentMillis = millis();
 // Incrementation par seconde
 if(currentMillis - previousMillis >= SECONDE) 
 {  
  // Garde en mémoire la valeur actuelle de millis()
  previousMillis = currentMillis;
  //Horloge     
  if(seconde==59)
  { 
     seconde=0;
     if(minute==59)
     {
        minute=0;
        if(heure==23)
        {
           heure=0;
        }
        else
        {
          heure++;
        }
     }
     else
     {
        minute++;
     }
  }
  else
  {
      seconde++;
  }
 }
}

//--------------------------------------------------------CHRONO-------------------------------------------------------//
void horloge_c()
{
 // Récupère la valeur actuelle de millis()
 unsigned long currentMillis = millis();
 // Incrementation par seconde
 if(currentMillis - previousMillis >= SECONDE) 
 {  
  // Garde en mémoire la valeur actuelle de millis()
  previousMillis = currentMillis;
  //Horloge     
  if(seconde_c==59)
  { 
     seconde_c=0;
     if(minute_c==59)
     {
        minute_c=0;
        if(heure_c==23)
        {
           heure_c=0;
        }
        else
        {
          heure_c++;
        }
     }
     else
     {
        minute_c++;
     }
  }
  else
  {
      seconde_c++;
  }
 }
}

//--------------------------------------------------------AFF-HOR-------------------------------------------------------//
void affichage_horloge()
{
      OLED.clearDisplay();
      OLED.setTextSize(2);
      OLED.setCursor(0,0);
      OLED.print(heure);
      OLED.print("h:");
      OLED.print(minute);
      OLED.print("m:");
      OLED.print(seconde);
      OLED.println("s");
      OLED.setTextSize(1);
      OLED.setCursor(0,25);
      OLED.println("Menu : press BT");
      OLED.display(); //output 'display buffer' to screen 
}

//--------------------------------------------------------AFF-CHRO-------------------------------------------------------//
void affichage_horloge_c()
{
      OLED.clearDisplay();
      OLED.setTextSize(2);
      OLED.setCursor(0,0);
      OLED.print(heure_c);
      OLED.print("h:");
      OLED.print(minute_c);
      OLED.print("m:");
      OLED.print(seconde_c);
      OLED.println("s");
      OLED.setTextSize(1);
      OLED.setCursor(0,25);
      OLED.println("Menu : press BT");
      OLED.display(); //output 'display buffer' to screen 
}

//--------------------------------------------------------MENU-HEURE-------------------------------------------------------//
void affichage_heure()
{
  horloge();
  affichage_horloge();
}

//--------------------------------------------------------MENU-CHRONO-------------------------------------------------------//
void affichage_chrono()
{  
  //init
  unsigned int heure_c=0;
  unsigned int minute_c=0;
  unsigned int seconde_c=0;
  
  affichage_horloge_c();
  
  //attente du bt: lancement du chrono
  while(digitalRead(BUTTON)!=HIGH)
  {
    horloge();    
  }
  //attente du bt: arret du chrono
  while(digitalRead(BUTTON)!=HIGH)
  {
    horloge(); 
    horloge_c();
    affichage_horloge();
  }
  //attente du bt: sortir du chrono
  while(digitalRead(BUTTON)!=HIGH)
  {
    horloge();    
  }
}

//--------------------------------------------------------MENU-DISTANCE-------------------------------------------------------//
void affichage_distance()
{
  while(digitalRead(BUTTON)!=HIGH)
  {
    horloge();
    /* 1. Lance une mesure de distance en envoyant une impulsion HIGH de 10µs sur la broche TRIGGER */
   digitalWrite(TRIGGER_PIN, HIGH);
   delayMicroseconds(10);
   digitalWrite(TRIGGER_PIN, LOW);
  
    /* 2. Mesure le temps entre l'envoi de l'impulsion ultrasonique et son écho (si il existe) */
   long measure = pulseIn(ECHO_PIN, HIGH, MEASURE_TIMEOUT);
   
   /* 3. Calcul la distance à partir du temps mesuré */
   float distance_mm = measure / 2.0 * SOUND_SPEED;
   
    /* Affiche les résultats en mm, cm et m */
   OLED.clearDisplay();
   OLED.setTextSize(1);
   OLED.setCursor(0,0);
   OLED.print(F("Distance: "));
   OLED.print(distance_mm / 10.0, 2);
   OLED.print(F("cm"));
   OLED.display(); //output 'display buffer' to screen 
  }
}

//--------------------------------------------------------PROVERBE-------------------------------------------------------//
void affichage_proverbe()
{
  String tableau[3] = {"Sauve un arbre, bouffe un castor !", "Donner c'est donne, repeindre ses volets.","Qui vole un oeuf, vole un oeuf."};
  int choix = random(0,2);
  while(digitalRead(BUTTON)!=HIGH)
  {
    horloge();
    OLED.clearDisplay();
    OLED.setTextSize(1);
    OLED.setCursor(0,0);
    OLED.print(tableau[choix]);
    OLED.display(); //output 'display buffer' to screen
  }
  while(digitalRead(BUTTON)!=HIGH)
  {
    horloge();
  }
}

//--------------------------------------------------------FHEURE-------------------------------------------------------//
void affichage_fheure()  
{
  int heures = random(0,23);
  int minutes = random(0,59);

  horloge();
  OLED.clearDisplay();
  OLED.setTextSize(1);
  OLED.setCursor(0,0);
  OLED.print("Quelque part dans le monde, il est ");
  OLED.print(heures);
  OLED.print("h ");
  OLED.print(minutes);
  OLED.print("min");
  OLED.display(); //output 'display buffer' to screen
} 
//--------------------------------------------------------BOUCLE INIT-------------------------------------------------------//
void setup()   
{
  initial();
} 

//--------------------------------------------------------BOUCLE INF--------------------------------------------------------//
void loop() 
{
  //Valeurs initiales
  int menu = 1;
  
  //Menu
  if(digitalRead(BUTTON)==HIGH)
  {
   menu++;
   delay(200);
  }
  switch(menu)
  {
    case 1 : affichage_heure();
             break;
    case 2 : affichage_distance();
             break;
    case 3 : affichage_chrono();
             break;
    case 4 : affichage_proverbe();
             break;
    case 5 : affichage_fheure();
             break;
    default: menu=1;
             break;      
  }
}
//--------------------------------------------------------FIN-------------------------------------------------------//
